/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO
 *
 */

package de.ivu.elect.business.statistik.boundary;

import javax.persistence.NoResultException;
import javax.persistence.NonUniqueResultException;
import javax.persistence.EntityNotFoundException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import de.ivu.elect.business.statistik.entity.StatistikKennzeichen;
import de.ivu.elect.business.statistik.entity.StatistikKennzeichenUK;

public abstract class AbstractStatistikKennzeichenDAO extends de.ivu.elect.jee.entity.AbstractDAO<StatistikKennzeichen,
        de.ivu.elect.business.statistik.entity.StatistikKennzeichenPK
    , StatistikKennzeichenUK> {

  private static final long serialVersionUID = 1L;

  private static final Logger LOG = LoggerFactory.getLogger(AbstractStatistikKennzeichenDAO.class);

  public AbstractStatistikKennzeichenDAO() {
    super();
  }

  public boolean isEntityWithPKPresent(
            de.ivu.elect.business.statistik.entity.StatistikKennzeichenPK
     pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk) != null;
    }

    return false;
  }

  @Override
  public StatistikKennzeichen findByPrimaryKey(
        de.ivu.elect.business.statistik.entity.StatistikKennzeichenPK
      pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk.getId());
    }

    throw new IllegalArgumentException("PK oder PK.getId() ist null! [pk = " + pk + "]");
  }


  @Override
  protected StatistikKennzeichen findByPrimaryKey(Long id) {
    if (id == null) {
      throw new IllegalArgumentException("ID ist null! [id = " + id + "]");
    }
  return getEntityManager().find(StatistikKennzeichen.class, id, CACHE_PROPERTIES);
  }



     /**
      * Name: ByLaufNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: DELETE FROM StatistikKennzeichen o WHERE o.statistikLauf = ?1<br>
      * SQL: <br>
      */
     public Integer deleteByLauf( @javax.annotation.Nonnull de.ivu.elect.business.statistik.entity.StatistikLauf lauf) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.statistik.entity.StatistikLauf laufCheckedAndAttached =  checkAndAttach(lauf, de.ivu.elect.business.statistik.entity.StatistikLauf.class, "lauf"); ;
		  
                              return
                    (Integer)
                              getEntityManager().
                                createNamedQuery("STATISTIK_KENNZEICHEN.ByLauf")
                              .setParameter(1, laufCheckedAndAttached)
                                                                                .executeUpdate();
          
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("StatistikKennzeichen, deleteByLauf - NonUniqueResultException, Parameter: "
           + ", lauf:'"+lauf+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".deleteByLauf(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: LaufNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM StatistikKennzeichen o WHERE o.statistikLauf = ?1<br>
      * SQL: <br>
      */
     public java.util.List<StatistikKennzeichen> findByLauf( @javax.annotation.Nonnull de.ivu.elect.business.statistik.entity.StatistikLauf lauf) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.statistik.entity.StatistikLauf laufCheckedAndAttached =  checkAndAttach(lauf, de.ivu.elect.business.statistik.entity.StatistikLauf.class, "lauf"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("STATISTIK_KENNZEICHEN.Lauf")
                              .setParameter(1, laufCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByLauf - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("StatistikKennzeichen, findByLauf - NonUniqueResultException, Parameter: "
           + ", lauf:'"+lauf+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByLauf(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }



  @Override
  public boolean isEntityWithUKPresent(de.ivu.elect.business.statistik.entity.StatistikKennzeichenUK uk) {
    try {
      return findByUK(uk) != null;
    } catch (javax.persistence.NoResultException nre) {
      return false;
    }
  }

  @Override
  public boolean isEntityWithUKHasPK(de.ivu.elect.business.statistik.entity.StatistikKennzeichenUK uk,
        de.ivu.elect.business.statistik.entity.StatistikKennzeichenPK
      pk

  ) {
    try {
      return findByUK(uk).getPk().equals(pk);
    } catch (NoResultException ignored) {
      // Do nothing - be happy.
    }
    return true;
  }

    public de.ivu.elect.business.statistik.entity.StatistikKennzeichen findByUK(de.ivu.elect.business.statistik.entity.StatistikKennzeichenUK uk){
        throw new UnsupportedOperationException("Kein UK definiert");
    }


}